
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>rabbitmq网络框架剖析 / 憋错料</title>

    <meta name="description" content="rabbitmq网络框架剖析 Rabbitmq是一个MQ系统,也就是消息中间件,它实现了AMQP 0.8规范,简单来说就是一个TCP的广播服务器.AMQP协议,你可以类比JMS,不过JMS仅仅是java领域内的API规范,而AMQP比JMS更进一步,它有自己的wire-level protocol,有一套可编程的协议,中立于语言.简单介绍了Rabbitmq之后,进入正题. Rabbitmq充分利用了Erlang的分布式.高可靠性.并发等特性,首先看它的一个结构图: 这张图展现了Rabbitmq的主要组件和组件之间的关系,具体">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">rabbitmq网络框架剖析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>Rabbitmq是一个MQ系统，也就是消息中间件，它实现了AMQP 0.8规范，简单来说就是一个TCP的广播服务器。AMQP协议，你可以类比JMS，不过JMS仅仅是java领域内的API规范，而AMQP比JMS更进一步，它有自己的wire-level protocol，有一套可编程的协议，中立于语言。简单介绍了Rabbitmq之后，进入正题。</p>
<p>Rabbitmq充分利用了Erlang的分布式、高可靠性、并发等特性，首先看它的一个结构图：<br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYmxvZy5jaGluYXVuaXgubmV0L2F0dGFjaG1lbnQvMjAxMzAzLzIyLzQyOTY1OV8xMzYzOTIxNjc4WnE0MS5wbmc=.jpg"></p>
<p>这张图展现了Rabbitmq的主要组件和组件之间的关系，具体到监控树的结构，我画了一张图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYmxvZy5jaGluYXVuaXgubmV0L2F0dGFjaG1lbnQvMjAxMzAzLzIyLzQyOTY1OV8xMzYzOTIxNzE4Mk0yMi5wbmc=.jpg"><br /><strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 顶层是rabbit_sup supervisor，它至少有两个子进程，一个是rabbit_tcp_client_sup，用来监控每个connection的处理进程 rabbit_reader的supervisor;rabbit_tcp_listener_sup是监控tcp_listener和 tcp_acceptor_sup的supervisor，tcp_listener里启动tcp服务器，监听端口，并且通过tcp_acceptor_sup启动N个tcp_accetpor，tcp_acceptor发起accept请求，等待客户端连接;tcp_acceptor_sup负责监控这些acceptor。这张图已经能给你一个大体的印象。</strong></p>
<p>讲完大概，进入细节，说说几个我觉的值的注意的地方：<br />1、<strong>tcp_accepto.erl,r对于accept采用的是异步方式</strong>，利用<strong>prim_inet:async_accept/2</strong>方法，此模块没有被文档化，是otp库内部使用,通常来说没必要使用这一模块，gen_tcp:accept/1已经足够，不过rabbitmq是广播程序，因此采用了异步方式。使用async_accept，需要打patch，以使得socket好像我们从gen_tcp:accept/1得到的一样：</p>
<ol>
<li>handle_info({inet_async,&nbsp;LSock,&nbsp;Ref,&nbsp;{ok,&nbsp;Sock}},</li>
<li>State&nbsp;=&nbsp;#state{callback={M,F,A},&nbsp;sock=LSock,&nbsp;ref=Ref})&nbsp;-&gt;</li>
<li>%%这里做了patch</li>
<li>%%&nbsp;patch&nbsp;up the&nbsp;socket&nbsp;so it looks like one we got&nbsp;from</li>
<li>%%&nbsp;gen_tcp:accept/1</li>
<li>{ok,&nbsp;Mod}&nbsp;=&nbsp;inet_db:lookup_socket(LSock),</li>
<li>inet_db:register_socket(Sock,&nbsp;Mod),</li>
<li>try</li>
<li>%%&nbsp;report</li>
<li>{Address,&nbsp;Port}&nbsp;=&nbsp;inet_op(fun&nbsp;()&nbsp;-&gt;&nbsp;inet:sockname(LSock)&nbsp;end),</li>
<li>{PeerAddress,&nbsp;PeerPort}&nbsp;=&nbsp;inet_op(fun&nbsp;()&nbsp;-&gt;&nbsp;inet:peername(Sock)&nbsp;end),</li>
<li>error_logger:info_msg("accepted TCP connection on ~s:~p from ~s:~p~n",</li>
<li>[inet_parse:ntoa(Address),&nbsp;Port,</li>
<li>inet_parse:ntoa(PeerAddress),&nbsp;PeerPort]),</li>
<li>%%&nbsp;调用回调模块，将Sock作为附加参数</li>
<li>apply(M,&nbsp;F,&nbsp;A&nbsp;++&nbsp;[Sock])</li>
<li>catch&nbsp;{inet_error,&nbsp;Reason}&nbsp;-&gt;</li>
<li>gen_tcp:close(Sock),</li>
<li>error_logger:error_msg("unable to accept TCP connection: ~p~n",</li>
<li>[Reason])</li>
<li>end,</li>
<li>%%&nbsp;继续发起异步调用</li>
<li>case&nbsp;prim_inet:async_accept(LSock,&nbsp;-1)&nbsp;of</li>
<li>{ok,&nbsp;NRef}&nbsp;-&gt;&nbsp;{noreply,&nbsp;State#state{ref=NRef}};</li>
<li>Error&nbsp;-&gt;&nbsp;{stop,&nbsp;{cannot_accept,&nbsp;Error},&nbsp;none}</li>
<li>end;</li>
<li>%%处理错误情况</li>
<li>handle_info({inet_async,&nbsp;LSock,&nbsp;Ref,&nbsp;{error,&nbsp;closed}},</li>
<li>State=#state{sock=LSock,&nbsp;ref=Ref})&nbsp;-&gt;</li>
<li>%%&nbsp;It would be wrong to attempt to restart the acceptor when we</li>
<li>%%&nbsp;know&nbsp;this&nbsp;will fail.</li>
<li>{stop,&nbsp;normal,&nbsp;State};</li>
</ol>
<p>2、<strong>rabbitmq内部是使用了多个并发acceptor</strong>，这在高并发下、大量连接情况下有效率优势，<strong>类似java现在的nio框架采用多个reactor类似</strong>，查看tcp_listener.erl:</p>
<ol>
<li>init({IPAddress,&nbsp;Port,&nbsp;SocketOpts,</li>
<li>ConcurrentAcceptorCount,&nbsp;AcceptorSup,</li>
<li>{M,F,A}&nbsp;=&nbsp;OnStartup,&nbsp;OnShutdown,&nbsp;Label})&nbsp;-&gt;</li>
<li>process_flag(trap_exit,&nbsp;true),</li>
<li>case&nbsp;gen_tcp:listen(Port,&nbsp;SocketOpts&nbsp;++&nbsp;[{ip,&nbsp;IPAddress},</li>
<li>{active,&nbsp;false}])&nbsp;of</li>
<li>{ok,&nbsp;LSock}&nbsp;-&gt;</li>
<li>%%创建ConcurrentAcceptorCount个并发acceptor</li>
<li>lists:foreach(fun&nbsp;(_)&nbsp;-&gt;</li>
<li>{ok,&nbsp;_APid}&nbsp;=&nbsp;supervisor:start_child(</li>
<li>AcceptorSup,&nbsp;[LSock])</li>
<li>end,</li>
<li>lists:duplicate(ConcurrentAcceptorCount,&nbsp;dummy)),</li>
<li>{ok,&nbsp;{LIPAddress,&nbsp;LPort}}&nbsp;=&nbsp;inet:sockname(LSock),</li>
<li>error_logger:info_msg("started ~s on ~s:~p~n",</li>
<li>[Label,&nbsp;inet_parse:ntoa(LIPAddress),&nbsp;LPort]),</li>
<li>%%调用初始化回调函数</li>
<li>apply(M,&nbsp;F,&nbsp;A&nbsp;++&nbsp;[IPAddress,&nbsp;Port]),</li>
<li>{ok,&nbsp;#state{sock&nbsp;=&nbsp;LSock,</li>
<li>on_startup&nbsp;=&nbsp;OnStartup,&nbsp;on_shutdown&nbsp;=&nbsp;OnShutdown,</li>
<li>label&nbsp;=&nbsp;Label}};</li>
<li>{error,&nbsp;Reason}&nbsp;-&gt;</li>
<li>error_logger:error_msg(</li>
<li>"failed to start ~s on ~s:~p - ~p~n",</li>
<li>[Label,&nbsp;inet_parse:ntoa(IPAddress),&nbsp;Port,&nbsp;Reason]),</li>
<li>{stop,&nbsp;{cannot_listen,&nbsp;IPAddress,&nbsp;Port,&nbsp;Reason}}</li>
<li>end.</li>
</ol>
<p>这里有一个技巧，如果要循环N次执行某个函数F，可以通过lists:foreach结合lists:duplicate(N,dummy)来处理。</p>
<p><strong><strong>lists:foreach(fun(_)-&gt; F() end,lists:duplicate(N,dummy)).</p>
<p>3、<strong>simple_one_for_one策略的使用</strong>，可以看到对于tcp_client_sup和tcp_acceptor_sup都采用了simple_one_for_one策略，而非普通的one_fo_one，这是为什么呢？<br />这牵扯到simple_one_for_one的几个特点：<br /><strong>1)simple_one_for_one内部保存child是使用dict，而其他策略是使用list</strong>，因此simple_one_for_one更适合child频繁创建销毁、需要大量child进程的情况，具体来说例如网络连接的频繁接入断开。<br /><strong>2)使用了simple_one_for_one后，无法调用terminate_child/2 delete_child/2 restart_child/2</p>
<p></strong>3)start_child/2 对于simple_one_for_one来说，不必传入完整的child spect，传入参数list，会自动进行<strong>参数合并</strong>。<strong>在一个地方定义好child spec之后，其他地方只要start_child传入参数即可启动child进程，简化child都是同一类型进程情况下的编程</strong>。</p>
<p>在 rabbitmq中，tcp_acceptor_sup的子进程都是tcp_acceptor进程，在tcp_listener中是启动了 ConcurrentAcceptorCount个tcp_acceptor子进程，通过supervisor:start_child/2方法：</p>
<p></strong></strong></p>
<ol>
<li>%%创建ConcurrentAcceptorCount个并发acceptor</li>
<li>lists:foreach(fun&nbsp;(_)&nbsp;-&gt;</li>
<li>{ok,&nbsp;_APid}&nbsp;=&nbsp;supervisor:start_child(</li>
<li>AcceptorSup,&nbsp;[LSock])</li>
<li>end,</li>
<li>lists:duplicate(ConcurrentAcceptorCount,&nbsp;dummy)),</li>
</ol>
<p><strong><br />注意到，这里调用的start_child只传入了<strong>LSock</strong>一个参数，另一个参数CallBack是在定义child spec的时候传入的，参见tcp_acceptor_sup.erl:<br /></strong></p>
<ol>
<li>init(Callback)&nbsp;-&gt;</li>
<li>{ok,&nbsp;{{simple_one_for_one,&nbsp;10,&nbsp;10},</li>
<li>[{tcp_acceptor,&nbsp;{tcp_acceptor,&nbsp;start_link,&nbsp;[Callback]},</li>
<li>transient,&nbsp;brutal_kill,&nbsp;worker,&nbsp;[tcp_acceptor]}]}}.</li>
</ol>
<p>Erlang内部自动为simple_one_for_one做了<strong>参数合并</strong>，最后调用的是tcp_acceptor的init/2:</p>
<ol>
<li>init({Callback,&nbsp;LSock})&nbsp;-&gt;</li>
<li>case&nbsp;prim_inet:async_accept(LSock,&nbsp;-1)&nbsp;of</li>
<li>{ok,&nbsp;Ref}&nbsp;-&gt;&nbsp;{ok,&nbsp;#state{callback=Callback,&nbsp;sock=LSock,&nbsp;ref=Ref}};</li>
<li>Error&nbsp;-&gt;&nbsp;{stop,&nbsp;{cannot_accept,&nbsp;Error}}</li>
<li>end.</li>
</ol>
<p>对于tcp_client_sup的情况类似，tcp_client_sup监控的子进程都是rabbit_reader类型，在 rabbit_networking.erl中启动tcp_listenner传入的处理connect事件的回调方法是是 rabbit_networking:start_client/1:</p>
<ol>
<li>start_tcp_listener(Host,&nbsp;Port)&nbsp;-&gt;</li>
<li>start_listener(Host,&nbsp;Port,&nbsp;"TCP Listener",</li>
<li>%回调的MFA</li>
<li>{?MODULE,&nbsp;start_client,&nbsp;[]}).</li>
<li>start_client(Sock)&nbsp;-&gt;</li>
<li>{ok,&nbsp;Child}&nbsp;=&nbsp;supervisor:start_child(rabbit_tcp_client_sup,&nbsp;[]),</li>
<li>ok&nbsp;=&nbsp;rabbit_net:controlling_process(Sock,&nbsp;Child),</li>
<li>Child&nbsp;!&nbsp;{go,&nbsp;Sock},</li>
<li>Child.</li>
</ol>
<p>start_client调用了supervisor:start_child/2来动态启动rabbit_reader进程。</p>
<p>4、<strong>协议的解析，消息的读取</strong>这部分也非常巧妙，这一部分主要在rabbit_reader.erl中，对于协议的解析没有采用gen_fsm，而是实现了一个巧妙的状态机机制,核心代码在mainloop/4中：</p>
<ol>
<li>%启动一个连接</li>
<li>start_connection(Parent,&nbsp;Deb,&nbsp;ClientSock)&nbsp;-&gt;</li>
<li>process_flag(trap_exit,&nbsp;true),</li>
<li>{PeerAddressS,&nbsp;PeerPort}&nbsp;=&nbsp;peername(ClientSock),</li>
<li>ProfilingValue&nbsp;=&nbsp;setup_profiling(),</li>
<li>try</li>
<li>rabbit_log:info("starting TCP connection ~p from ~s:~p~n",</li>
<li>[self(),&nbsp;PeerAddressS,&nbsp;PeerPort]),</li>
<li>%延时发送握手协议</li>
<li>Erlang:send_after(?HANDSHAKE_TIMEOUT&nbsp;*&nbsp;1000,&nbsp;self(),</li>
<li>handshake_timeout),</li>
<li>%进入主循环，更换callback模块，魔法就在这个switch_callback</li>
<li>mainloop(Parent,&nbsp;Deb,&nbsp;switch_callback(</li>
<li>#v1{sock&nbsp;=&nbsp;ClientSock,</li>
<li>connection&nbsp;=&nbsp;#connection{</li>
<li>user&nbsp;=&nbsp;none,</li>
<li>timeout_sec&nbsp;=&nbsp;?HANDSHAKE_TIMEOUT,</li>
<li>frame_max&nbsp;=&nbsp;?FRAME_MIN_SIZE,</li>
<li>vhost&nbsp;=&nbsp;none},</li>
<li>callback&nbsp;=&nbsp;uninitialized_callback,</li>
<li>recv_ref&nbsp;=&nbsp;none,</li>
<li>connection_state&nbsp;=&nbsp;pre_init},</li>
<li>%%注意到这里，handshake就是我们的回调模块，8就是希望接收的数据长度，AMQP协议头的八个字节。</li>
<li>handshake,&nbsp;8))</li>
</ol>
<p>魔法就在switch_callback这个方法上：</p>
<ol>
<li>switch_callback(OldState,&nbsp;NewCallback,&nbsp;Length)&nbsp;-&gt;</li>
<li>%发起一个异步recv请求，请求Length字节的数据</li>
<li>Ref&nbsp;=&nbsp;inet_op(fun&nbsp;()&nbsp;-&gt;&nbsp;rabbit_net:async_recv(</li>
<li>OldState#v1.sock,&nbsp;Length,&nbsp;infinity)&nbsp;end),</li>
<li>%更新状态，替换ref和处理模块</li>
<li>OldState#v1{callback&nbsp;=&nbsp;NewCallback,</li>
<li>recv_ref&nbsp;=&nbsp;Ref}.</li>
</ol>
<p>异步接收Length个数据，如果有，erlang会通知你处理。处理模块是什么概念呢？其实就是一个状态的概念，表示当前协议解析进行到哪一步，起一个label的作用，看看mainloop/4中的应用：</p>
<ol>
<li>mainloop(Parent,&nbsp;Deb,&nbsp;State&nbsp;=&nbsp;#v1{sock=&nbsp;Sock,&nbsp;recv_ref&nbsp;=&nbsp;Ref})&nbsp;-&gt;</li>
<li>%%?LOGDEBUG("Reader mainloop: ~p bytes available, need ~p~n",&nbsp;[HaveBytes,&nbsp;WaitUntilNBytes]),</li>
<li>receive</li>
<li>%%接收到数据，交给handle_input处理,注意handle_input的第一个参数就是callback</li>
<li>{inet_async,&nbsp;Sock,&nbsp;Ref,&nbsp;{ok,&nbsp;Data}}&nbsp;-&gt;</li>
<li>%handle_input处理</li>
<li>{State1,&nbsp;Callback1,&nbsp;Length1}&nbsp;=</li>
<li>handle_input(State#v1.callback,&nbsp;Data,</li>
<li>State#v1{recv_ref&nbsp;=&nbsp;none}),</li>
<li>%更新回调模块，再次发起异步请求，并进入主循环</li>
<li>mainloop(Parent,&nbsp;Deb,</li>
<li>switch_callback(State1,&nbsp;Callback1,&nbsp;Length1));</li>
</ol>
<p>handle_input有多个分支，每个分支都对应一个处理模块，例如我们刚才提到的握手协议：</p>
<ol>
<li>%handshake模块，注意到第一个参数，第二个参数就是我们得到的数据</li>
<li>handle_input(handshake,&nbsp;&lt;&lt;"AMQP",1,1,ProtocolMajor,ProtocolMinor&gt;&gt;,</li>
<li>State&nbsp;=&nbsp;#v1{sock&nbsp;=&nbsp;Sock,&nbsp;connection&nbsp;=&nbsp;Connection})&nbsp;-&gt;</li>
<li>%检测协议是否兼容</li>
<li>case&nbsp;check_version({ProtocolMajor,&nbsp;ProtocolMinor},</li>
<li>{?PROTOCOL_VERSION_MAJOR,&nbsp;?PROTOCOL_VERSION_MINOR})&nbsp;of</li>
<li>true&nbsp;-&gt;</li>
<li>{ok,&nbsp;Product}&nbsp;=&nbsp;application:get_key(id),</li>
<li>{ok,&nbsp;Version}&nbsp;=&nbsp;application:get_key(vsn),</li>
<li>%兼容的话，进入connections start，协商参数</li>
<li>ok&nbsp;=&nbsp;send_on_channel0(</li>
<li>Sock,</li>
<li>#‘connection.start‘{</li>
<li>version_major&nbsp;=&nbsp;?PROTOCOL_VERSION_MAJOR,</li>
<li>version_minor&nbsp;=&nbsp;?PROTOCOL_VERSION_MINOR,</li>
<li>server_properties&nbsp;=</li>
<li>[{list_to_binary(K),&nbsp;longstr,&nbsp;list_to_binary(V)}&nbsp;||</li>
<li>{K,&nbsp;V}&nbsp;&lt;-</li>
<li>[{"product",&nbsp;Product},</li>
<li>{"version",&nbsp;Version},</li>
<li>{"platform",&nbsp;"Erlang/OTP"},</li>
<li>{"copyright",&nbsp;?COPYRIGHT_MESSAGE},</li>
<li>{"information",&nbsp;?INFORMATION_MESSAGE}]],</li>
<li>mechanisms&nbsp;=&nbsp;&lt;&lt;"PLAIN AMQPLAIN"&gt;&gt;,</li>
<li>locales&nbsp;=&nbsp;&lt;&lt;"en_US"&gt;&gt;&nbsp;}),</li>
<li>{State#v1{connection&nbsp;=&nbsp;Connection#connection{</li>
<li>timeout_sec&nbsp;=&nbsp;?NORMAL_TIMEOUT},</li>
<li>connection_state&nbsp;=&nbsp;starting},</li>
<li>frame_header,&nbsp;7};</li>
<li>%否则，断开连接，返回可以接受的协议</li>
<li>false&nbsp;-&gt;</li>
<li>throw({bad_version,&nbsp;ProtocolMajor,&nbsp;ProtocolMinor})</li>
<li>end;</li>
</ol>
<p>其他协议的处理也是类似，通过动态替换callback的方式来模拟状态机做协议的解析和数据的接收，真的很巧妙！让我们体会到Erlang的魅力，FP的魅力。</p>
<p><strong>5、序列图：</strong><br />1）tcp server的启动过程：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYmxvZy5jaGluYXVuaXgubmV0L2F0dGFjaG1lbnQvMjAxMzAzLzIyLzQyOTY1OV8xMzYzOTIyMzE1Z2Y0Vy5wbmc=.jpg"></p>
<p>2）一个client连接上来的处理过程：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYmxvZy5jaGluYXVuaXgubmV0L2F0dGFjaG1lbnQvMjAxMzAzLzIyLzQyOTY1OV8xMzYzOTIyMzU3NEoxeS5wbmc=.jpg"></p>
<p>小结：从上面的分析可以看出,rabbitmq的网络层是非常健壮和高效的，通过层层监控，对每个可能出现的风险点都做了考虑，并且利用了prim_net模块做异步IO处理。分层也是很清晰，将业务处理模块隔离到client_sup监控下的子进程，将网络处理细节和业务逻辑分离。在协议的解析和业务处理上虽然没有采用gen_fsm，但是也实现了一套类似的状态机机制，通过动态替换Callback来模拟状态的变迁，非常巧妙。如果你要实现一个tcp server，强烈推荐从rabbitmq中扣出这个网络层，你只需要实现自己的业务处理模块即可拥有一个高效、健壮、分层清晰的TCP服务器。</p>
<p>网友讨论：<br />prim_inet，按照余锋老大的说法是可以用的，基本上接口不会有大的变更，gen_tcp其实是基于prim_net实现的。</p>
<p>使用simple_one_for_one，可以有多个child的，只不过这些child的是同一种类型的，看supervisor.erl的源码就知道，内部是动态保存在一个dict结构里dynamics = ?DICT:new(),因此是可保存多个：</p>
<ol>
<li>{ok,&nbsp;Pid}&nbsp;-&gt;</li>
<li>NState&nbsp;=&nbsp;State#state{dynamics&nbsp;=</li>
<li>?DICT:store(Pid,&nbsp;Args,&nbsp;State#state.dynamics)},</li>
<li>{reply,&nbsp;{ok,&nbsp;Pid},&nbsp;NState};</li>
</ol>
<p>文章来自：http://blog.chinaunix.net/uid-429659-id-3536524.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-12 02:38:54 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/state/" title="state">state</a>, <a href="https://www.biecuoliao.com/tag/shutdown/" title="shutdown">shutdown</a>, <a href="https://www.biecuoliao.com/tag/%e5%b9%b6%e4%b8%94/" title="并且">并且</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%9c%e7%94%a8/" title="作用">作用</a>, <a href="https://www.biecuoliao.com/tag/cas/" title="cas">cas</a>, <a href="https://www.biecuoliao.com/tag/%e5%81%9a%e4%ba%86/" title="做了">做了</a>, <a href="https://www.biecuoliao.com/tag/ica/" title="ica">ica</a>, <a href="https://www.biecuoliao.com/tag/%e5%9f%ba%e4%ba%8e/" title="基于">基于</a>, <a href="https://www.biecuoliao.com/tag/%e9%99%84%e5%8a%a0/" title="附加">附加</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>rabbitmq网络框架剖析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mob1lw4.html" rel="bookmark">volley 框架剖析（一） 面向接口的编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Volley是Google出品的一个轻量级的网络框架,默认实现,主要用于小数据量的网络请求.这里就按从粗到细,自上而下的过程,给大家剖析这个牛X的框架. 这个框架的代码量虽少,但却把面向接口的编程这个原则发挥的淋漓尽致.这个框架是怎么构成的呢? 先看包的结构. 有com.android.volley 及 com.android.volley.toolbox两个包. 其中com.android.volley中的接口和类,是基础框架,构成了一个基于队列的网络请求功能. 而com.android.vo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wq658M.html" rel="bookmark">教你写Android网络框架之Http请求的分发与执行</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 在&lt;教你写Android网络框架&gt;专栏的前两篇博客中,我们已经介绍了SimpleNet框架的基本结构,以及Request.Response.请求队列的实现,以及为什么要这么设计,这么设计的考虑是什么.前两篇博客中已经介绍了各个角色,今天我们就来剖析另外几个特别重要的角色,即NetworkExecutor.HttpStack以及ResponseDelivery,它们分别对应的功能是网络请求线程.Http执行器.Response分发,这三者是执行http请求和处理Response的核心. 我			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RdpRj4.html" rel="bookmark">教你写Android网络框架之请求配置与Response缓存</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 在教你写Android网络框架的前三篇文章中,我们从基本结构到代码实现,剖析了一个简单的网络框架应该是怎样运作的,以及在面对各式各样的需求时应该如何对代码做出处理,在深入了解网络框架的同时学习到一些简单的面向对象设计原则.正如第一篇博文所说,SimpleNet框架参照的是Volley实现,甚至有一些类名也是一样的.我们的目标并不是要重新发明轮子,而是以学习轮子制作的过程来达到提升自我的目的.SimpleNet只是一个简单的网络框架实现,没有经过严格的测试以及市场检验,不建议大家在项目中使用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RdzBy4.html" rel="bookmark">教你写Android网络框架之Request、Response类与请求队列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处,本文来自[ Mr.Simple的博客 ]. 我正在参加博客之星,点击这里投我一票吧,谢谢~ 前言 在教你写Android网络框架之基本架构一文中我们已经介绍了SimpleNet网络框架的基本结构,今天我们就开始从代码的角度来开始切入该网络框架的实现,在剖析的同时我们会分析设计思路,以及为什么要这样做,这样做的好处是什么.这样我们不仅学到了如何实现网络框架,也会学到设计一个通用的框架应该有哪些考虑,这就扩展到框架设计的范畴,通过这个简单的实例希望能给新人一些帮助.当然这只是一家之言			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/w3vyvk0.html" rel="bookmark">python 网络框架twisted基础学习及详细讲解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				twisted网络框架的三个基础模块:Protocol, ProtocolFactory, Transport.这三个模块是构成twisted服务器端与客户端程序的基本. Protocol:Protocol对象实现协议内容,即通信的内容协议ProtocolFactory: 是工厂模式的体现,在这里面生成协议Transport: 是用来收发数据,服务器端与客户端的数据收发与处理都是基于这个模块 在windows中安装twisted需要先安装pywin32,自己去下载下就行.随后pip instal			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38N8PWM.html" rel="bookmark">发布C&plus;&plus;实现的TCP网络框架Khala</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.Khala简介 Khala(卡拉)是用C++实现的TCP网络框架.底层采用muduo网络库作为网络IO+线程模型,并封装实现了网络实现与业务逻辑分离的多线程网络框架,具有超时退出.多设备多事件注册支持.设备生命周期管理.设备间通信等功能. 项目托管地址:https://github.com/moyangvip/khala 2.底层支持 Khala底层采用muduo作为网络IO支持.muduo类似于市面上一些常用开源event-driven网络库(如libevent),实现了基于Reactor			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xQxqn3.html" rel="bookmark">【Android】自己写的轻量级安卓网络框架&mdash;&mdash;能够控制网络连接，支持缓存</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1原因: 之所以写这个框架是因为网上的好多的网络框架都没有很好的对网络连接进行控制,比如当你点击取消的时候只是对话框取消了,后台网络请求还是在继续,这样就造成了activity的无法释放,更严重的情况是降低APP流畅度,所以就结合自己的需求写了个这样轻量级的网络框架 2解决方案: 我已经开源了,放在了OSC上,框架目前还不是很完善,所以需要慢慢改善,不过这个流程目前感觉是非常不错的,当activity销毁的时候基本不会存在无法释放问题.当你点击取消的时候也不会出现后台网络请求还在继续的情况. h			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eAemv0.html" rel="bookmark">Android网络框架OkHttp之get请求（源码初识）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概括 OkHttp现在很火呀.于是上个星期就一直在学习OkHttp框架,虽然说起来已经有点晚上手了,貌似是2013年就推出了.但是现在它版本更加稳定了呀.这不,说着说着,OkHttp3.3版本在这几天又发布了.以下以OkHttp3.2版本为准,没办法,上个星期看的时候还是以3.2为最新版本的.首先,我们要先了解一些背景,OkHttp这个框架是有Square公司推出的,进入官网.如果想看API,点击进入API.大概了解了OkHttp之后,我们应该知道OkHttp是一个网络框架,想想以前在开发中,网			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3r2jkb3.html" rel="bookmark">迅速上手Retrofit&plus;RxJava&plus;Okhttp&plus;FastJson的网络框架&lbrack;RRO&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Retrofit以其灵活的调用形式, 强大的扩展性著称. 随着RxAndroid的推出, Retrofit这样的可插拔式的网络框架因其可以灵活兼容各种数据解析器, 回调形式(主要还是RxJava啦)而更加风靡. 但是! Retrofit2官方虽有一堆集成第三方json解析的实现,比如gson-converter等等..但唯独就是没有FastJson, 这让我很不解..于是自己动手模仿gson-converter写了一个fastjson-converter, 并封装为一个更易用的适合Android			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/L3rZ1a3.html" rel="bookmark" class="title">HTTP协议 &lpar;七&rpar; Cookie</a>
					<div>
						Cookie是HTTP协议中非常重要的东西, 之前拜读了Fish Li 写的[细说Cookie], 让我学到了很多东西.Fish的这篇文章写得太经典了. 所以我这篇文章就没有太多内容了. 最近我打算写 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/g41ZakM.html" rel="bookmark" class="title">svg学习笔记（一）</a>
					<div>
						SVG——可扩展适量图形,基于XML PC端:IE9+   wap端:表现良好,适合使用 基础图形: line(线段)  &lt;line x1=&quot;25&quot; y1=&quot;150 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JDkmV0.html" rel="bookmark" class="title">我的2015技术学习流水账</a>
					<div>
						我的2015技术学习流水账 2015年马上就要过去了,匆匆忙忙地又是一年.回头总结整理,发现这一年还挺充实的.在正常上班工作之余,学习到了不少新东西,不禁感到很欣慰!一个多月前就开始写,终于赶在201 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38NDxgM.html" rel="bookmark" class="title">爱因斯坦的光线（Einstein&rsquo;s Light Beam）</a>
					<div>
						史上第七大哲学命题:爱因斯坦的光线(Einstein's Light Beam) ~ 爱因斯坦著名的狭义相对论是受启于他16岁做的思想实验.在他的自传中,爱因斯坦回忆道他当时幻想在宇宙中追寻一道光线. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02mgPzM.html" rel="bookmark" class="title">Zabbix3&period;0 监控HW交换机</a>
					<div>
						Zabbix服务器IP地址: 10.16.3.252 HW交换机IP地址:  10.16.100.2 1.zabbix服务器是通过snmp协议对交换机进行监控.所以,首先需要在交换机上开启SNMP应用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MG8kjb0.html" rel="bookmark" class="title">POJ 1191 棋盘分割</a>
					<div>
						棋盘分割 Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 11938   Accepted: 4207 Description ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXQjPG0.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;玲珑杯&rdquo;郑州轻工业学院第八届ACM程序设计大赛暨河南高校邀请赛-正式赛</a>
					<div>
						1874: 蛤玮学计网 Time Limit: 1 Sec  Memory Limit: 128 MB Submit: 854  Solved: 120 SubmitStatusWeb Board D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wyXkbM.html" rel="bookmark" class="title">layout&lowbar;gravity</a>
					<div>
						layout_gravity——当前View,本身,在父一级的控件所分配的显示范围内的,对齐方式 常用在: 当前控件(在父一级LineLayout所分配给其的显示范围内)的对齐方式 需要注意的是,如果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qaKla3.html" rel="bookmark" class="title">python中出现IndentationError&colon;unindent does not match any outer indentation level错误</a>
					<div>
						python中出现IndentationError:unindent does not match any outer indentation level 今天在网上copy的一段代码.代码非常eas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KOkkw0.html" rel="bookmark" class="title">OK335xS UART device registe hacking</a>
					<div>
						/************************************************************************* * OK335xS UART device reg ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzAovW4.html" rel="bookmark" class="title">IO多路复用之epoll总结</a>
					<div>
						1.基本知识 epoll是在2.6内核中提出的(mac没有),是之前的select和poll的增强版本.相对于select和poll来说,epoll更加灵活,没有描述符限制.epoll使用一个文件描述 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mo5LJb3.html" rel="bookmark" class="title">logscan设计</a>
					<div>
						模块划分 数据库表设计 agent设计 agent结构 controller 负责每隔一段时间调度FileAnalyzer一次,将RuleConfig启动起来 ruleConfig 负责在本地保存配置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KZoxLM.html" rel="bookmark" class="title">进程的守护进程的用法</a>
					<div>
						编写守护进程的步骤: 1.创建子进程,父进程退出. 2.在子进程中创建新会话. setsid(); 3.改变当前目录为根目录. chdir(&quot;/&quot;); 4.重设文件权限掩码. um ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rz6W13.html" rel="bookmark" class="title">proxool &plus; MySQL &plus; servelt 的使用</a>
					<div>
						Proxool 简介 Proxool连接池是sourceforge下的一个开源项目,这个项目提供一个健壮.易用的连接池,最为关键的是这个连接池提供监控的功能,方便易用,便于发现连接泄漏的情况.开源项目 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEWXVg3.html" rel="bookmark" class="title">javascript之字符串函数</a>
					<div>
						(1)anchor函数:产生一个链接点(anchor)以作超级链接用.anchor函数设定&lt;ANAME...&gt;的链接点的名称,另一个函数link设定&lt;A HREF=...&gt;的U ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AaolD4.html" rel="bookmark" class="title">iOS数组排序</a>
					<div>
						[_fields sortUsingComparator:^NSComparisonResult(UITextField *obj1, UITextField *obj2) { /* NSOrdere ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k6bNpM.html" rel="bookmark" class="title">这个写法会出什么问题： &commat;property &lpar;copy&rpar; NSMutableArray &ast;array&semi;</a>
					<div>
						因为copy策略拷贝出来的是一个不可变对象,然而却把它当成可变对象使用,很容易造成程序奔溃 这里还有一个问题,该属性使用了同步锁,会在创建时生成一些额外的代码用于帮助编写多线程程序,这会带来性能问题, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YLzAWM.html" rel="bookmark" class="title">jquery 点击当前input元素对象获取下一个input对象</a>
					<div>
						&lt;div class=&quot;apps_container&quot;&gt; &lt;input type=&quot;hidden&quot; value=&quot;00070008& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k2vjbM.html" rel="bookmark" class="title">ORACLE常用数值函数、转换函数、字符串函数</a>
					<div>
						本文并不准备介绍全部的oracle函数,当前情势下,俺也还没这个时间,需要学习的东西太多了,要把多数时间花在学习经常能用上的技术方面:),所以如果是准备深入了解所有oracle函数的朋友,还是去关注: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGn2d64.html" rel="bookmark" class="title">Mingyang&period;net：自定义FreeMarkerView</a>
					<div>
						自定义FreeMarkerView的目的是为了放一些公共的变量到FreeMarker模版里面.spring-context.xml: &lt;!-- ************************* ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
